`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Erstes kleines Verilog-Testprogramm 
// 
// 
// Create Date:    19:51:11 06/04/2008 
// 
// Module Name:    Source1 
//  
// Target Devices: XC3S100E
// Tool versions:  Webpack 8.2i
// Description:    Laesst einfach die LEDs leuchten wenn man auf die Tasten drueckt
//
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////


// Hier wird erstmal definiert was wir alles an Ein und Ausgaengen brauchen
// Es ist aber noch notwendig unter User Contstraints/Assign Package Pins
// genau festzulegen wo denn nun die Sachen am FPGA angeschlossen sind.
module Source1(CLK_I, Led1, Led2, Led3, Led4, Taste1, Taste2, Taste3, Taste4,
               DP1OEN_O, DP2OEN_O, DP3OEN_O, DP4OEN_O, SEG_O,
               MAX_CS,MAX_DIN,MAX_DOUT,MAX_SCK);

   output MAX_CS;         // CS fuer den MAX1248
   output MAX_DIN;        // Daten zum Max1248
   input  MAX_DOUT;       // Datein vom Max1248
   output MAX_SCK;        // Clock fuer den Max1248
   
   output Led1;           // Das sind die vier Ausgaenge der LEDs
   output Led2;
   output Led3;
   output Led4;
	 
   input   Taste1;				// Das sind unsere vier Taster
   input   Taste2;
   input   Taste3;
   input   Taste4;
	 
   input  CLK_I;				// Hier haengt ein 33Mhz Quarz dran
	 
   output DP1OEN_O;       // Die Enableausgaenge zur Stellenauswahl des 7Segment
   output DP2OEN_O;
   output DP3OEN_O;
   output DP4OEN_O;
   output reg [8:1] SEG_O; //Ausgabe der Stelle selber als Registerausgang
	 
	

    // Ab hier Definition unserer Variablen bzw. Register.	 
   reg [7:0] 	    Seg1;  // Zwischenspeicher fuer die einzelen LEDs
   reg [7:0] 	    Seg2;  // der 7Segmenanzeige
   reg [7:0] 	    Seg3;
   reg [7:0] 	    Seg4;
	 
   reg [3:0] 	    count1;	//Einerstelle des 7Segment
   reg [3:0] 	    count2;	//Zehnerstelle
   reg [3:0] 	    count3;	//Hunderterstelle
   reg [3:0] 	    count4;	//Tausenderstelle
	 
   reg [19:0] 	    OEN_Count; //Counter fuer das Multiplexing des 7SegLED
   wire [1:0] 	    OE_Digit;  //Stellenauswahl fuer Multiplexing
   reg [4:1] 	    SEGEN_O;   //Hilfsregister fuer Ausgabe der OutputEnable
	
   parameter [31:0] Faktor = 32'h01F78A40;  // Teilerfaktor fuer 33Mhz
   reg [31:0] 	    Sek_Zaehler;            // Zaehler fuer 1Sekunde
   reg 		    pulse1sek;

   parameter [31:0] SPI_Clock = 32'h00325AA0; // Erstmal 10Hz fuer Testzwecke
   reg [31:0] 	    SPI_Counter;
   reg 		    SPI_CLK;
	 
   //reg [7:0] 	    MAX_CommandReg;            // Kommandoregister fuer MAX1248
	
   reg [3:0] 	    state;
   reg [3:0] 	    next_state;
   
   parameter S_0 = 4'b0000;
   parameter S_1 = 4'b0001;
   parameter S_2 = 4'b0010;
 
   parameter S_3 = 4'b0011,
	     S_4 = 4'b0100, 
             S_5 = 4'b0101, 
             S_6 = 4'b0110, 
             S_7 = 4'b0111;
	
   reg 		    clockout;
   reg 		    datenout;
   reg [7:0] 	    tmp;
   integer 	    bitcounter;
	
   // Erstmal nur testen ob unsere Ausgaenge auch hinhauen
   assign MAX_CS =  !Taste1;
   assign MAX_DIN = !Taste2;
   assign MAX_SCK = !Taste3;
	assign Led3    = !Taste3;
   assign Led4    = !Taste4;	
   

    // Aufwaertszaehler der einen Takt von 1Sekunde liefert.		
   always @(posedge CLK_I)
     begin
	if (Sek_Zaehler == Faktor) 	//Maximawert erreicht
	  begin
	     pulse1sek	<= 1'b1;	   //Pulse erzeugen
	     Sek_Zaehler <= 32'b0;   //Zaehler zuruecksetzen
	  end
	else
	  begin
	     pulse1sek <= 1'b0;      // Pulse abschalten
	     Sek_Zaehler <= Sek_Zaehler +1; //Weiter zaehlen
	  end
     end

   // Aufwaertszaehler der den Takt fuer den SPI-Bus zum AD-Wandler liefert
   always @(posedge CLK_I)
     begin
	if (SPI_Counter == SPI_Clock) 	//Maximawert erreicht
	  begin
	     SPI_CLK	 <= 1'b1;	   //Pulse erzeugen
	     SPI_Counter <= 32'b0;   //Zaehler zuruecksetzen
	  end
	else
	  begin
	     SPI_CLK     <= 1'b0;      // Pulse abschalten
	     SPI_Counter <= SPI_Counter +1; //Weiter zaehlen
	  end
     end

   //Ausgabe eines Datenbit und generierung des notwendigen Clocks
   //Ausserdem bei Reset das Datenregister initialisieren
   always@(state)
     begin 
	case (state)
	  S_0 : begin		        
	     $display("S_0");
	     tmp <= {tmp[6:0], 1'b1 /* MAX_DOUT*/ }; //Datenbit ausgeben und einlesen
	     next_state <= S_1;
	  end	
	  S_1 : begin		      
	     $display("S_1");
	     clockout <= 1'b1;                       //Clock auf HighPegel
             next_state <= S_2;				 
          end
			 
	  S_2 : begin
	         $display("S_2");
	         clockout <= 1'b0;                       //Clock auf Low
            bitcounter = bitcounter +1;
            if (bitcounter == 7) next_state <= S_7;
            else                 next_state <= S_0;
           end
			  
	  S_6 : begin
	     $display("S_6");
	     tmp <= 8'b11110000;        //Bei Reset Kommandowort laden
	     bitcounter = 0;
             next_state <= S_0;         //Statemachine starten
          end	
	  S_7 : begin                        //Wir sind fertig
	     $display("S_7");
             next_state <= S_7;
          end				  
	endcase
     end

   
	//LEDs muessen invertiert werden damit 1=on!
   assign Led1 = !tmp[7];
   assign Led2 = !clockout;		

   //Haelt unser Statemachine in Schwung 
   always @(posedge SPI_CLK)
     begin
	if (Taste1 == 1'b1)  //Das ist erstmal unsere Resettaste
	  begin
	     state <= S_6;
	     $display("Reset!");
	     
	     //  tmp <= 8'b10101010;		 
	  end
	else
	  begin
	     $display("Tick-Tack");
	     state <= next_state; //Statemachine triggern 
	  end
     end

	 

    // Einmal pro Sekunde unsere Register fuer das 7Segment LED raufzaehlen.	
   always @(posedge pulse1sek)
     begin
	
	if (Taste1 == 1'b1) //Bei Tastendruck LED einschalten und Zaehler reseten
	  begin	  	
	     count1 <= 4'b0000;
	     count2 <= 4'b0000;
	     count3 <= 4'b0000;
	     count4 <= 4'b0000;	   
	  end
	else
	  begin
	     if (count1 == 4'b1001 ) 
	       begin
		  count1 <= 4'b0000;
		  if (count2 == 4'b1001)
		    begin
		       count2 <= 4'b0000;
		       if (count3 == 4'b1001) 
			 begin 
			    count3 <= 4'b0000;
			    if (count4 == 4'b1001)
			      begin
				 count4 <= 4'b0000;
			      end
			    else
			      begin
				 count4 <= count4 +1;
			      end
			 end
		       else begin	count3 <= count3 +1;	end
		    end
		  else begin count2 <=count2+1; end
	       end
	     else begin count1 <= count1 +1; end
	     
	  end		
     end
		
  // assign Led1 = merker;		
		
   // Konvertiert bei jedem Clk die Inhalte der 4Bit Zaehlregister in 7Segmentwerte
   // fuer das 7Seg-LED
   always @(posedge CLK_I)
     begin
	case ( count4 ) //1000er Stelle
	  4'b0000	:	Seg4 <= 8'b00111111;
	  4'b0001	:	Seg4 <= 8'b00000110;
	  4'b0010       :	Seg4 <= 8'b01011011;
	  4'b0011	:	Seg4 <= 8'b01001111;
	  4'b0100	:	Seg4 <= 8'b01100110;
	  4'b0101	:	Seg4 <= 8'b01101101;
	  4'b0110	:	Seg4 <= 8'b01111101;
	  4'b0111	:	Seg4 <= 8'b00100111;
	  4'b1000	:	Seg4 <= 8'b01111111;
	  4'b1001	:	Seg4 <= 8'b01101111;
	  default	:	Seg4 <= 8'b01000000;
	endcase

	case ( count3 ) //100er Stelle
	  4'b0000	:	Seg3 <= 8'b00111111;
	  4'b0001	:	Seg3 <= 8'b00000110;
	  4'b0010       :	Seg3 <= 8'b01011011;
	  4'b0011	:	Seg3 <= 8'b01001111;
	  4'b0100	:	Seg3 <= 8'b01100110;
	  4'b0101	:	Seg3 <= 8'b01101101;
	  4'b0110	:	Seg3 <= 8'b01111101;
	  4'b0111	:	Seg3 <= 8'b00100111;
	  4'b1000	:	Seg3 <= 8'b01111111;
	  4'b1001	:	Seg3 <= 8'b01101111;
	  default	:	Seg3 <= 8'b01000000;
	endcase

	case ( count2 ) //10er Stelle
	  4'b0000	:	Seg2 <= 8'b00111111;
	  4'b0001	:	Seg2 <= 8'b00000110;
	  4'b0010       :	Seg2 <= 8'b01011011;
	  4'b0011	:	Seg2 <= 8'b01001111;
	  4'b0100	:	Seg2 <= 8'b01100110;
	  4'b0101	:	Seg2 <= 8'b01101101;
	  4'b0110	:	Seg2 <= 8'b01111101;
	  4'b0111	:	Seg2 <= 8'b00100111;
	  4'b1000	:	Seg2 <= 8'b01111111;
	  4'b1001	:	Seg2 <= 8'b01101111;
	  default	:	Seg2 <= 8'b01000000;
	endcase

	case ( count1 ) //1er Stelle
	  4'b0000	:	Seg1 <= 8'b00111111;
	  4'b0001	:	Seg1 <= 8'b00000110;
	  4'b0010       :	Seg1 <= 8'b01011011;
	  4'b0011	:	Seg1 <= 8'b01001111;
	  4'b0100	:	Seg1 <= 8'b01100110;
	  4'b0101	:	Seg1 <= 8'b01101101;
	  4'b0110	:	Seg1 <= 8'b01111101;
	  4'b0111	:	Seg1 <= 8'b00100111;
	  4'b1000	:	Seg1 <= 8'b01111111;
	  4'b1001	:	Seg1 <= 8'b01101111;
	  default	:	Seg1 <= 8'b01000000;
	endcase
     end
	 
   // Einen Zaehler fuer das Multiplexing generieren
   always @(posedge CLK_I)
     begin
	OEN_Count <= OEN_Count +1;
     end
	 
   // Wir waehlen und zwei Bits aus dem Zaehler aus
   assign  OE_Digit = OEN_Count[17:16];
	 
   //Gibt die jeweilige Stelle an das Display aus. (invertiert!)
   always @(posedge CLK_I)
     begin
	case (OE_Digit)
	  2'b00	:	SEG_O <= ~Seg1;
	  2'b01	:	SEG_O <= ~Seg2;
	  2'b10	:	SEG_O <= ~Seg3;
	  2'b11	:	SEG_O <= ~Seg4;
	endcase
     end
	 
   //Schaltet die Stelle des 4x 7Seg-Leds ein
   always @(posedge CLK_I)
     begin
	case (OE_Digit)
	  2'b00	:	SEGEN_O <= 4'b0001;
	  2'b01	:	SEGEN_O <= 4'b0010;
	  2'b10	:	SEGEN_O <= 4'b0100;
	  2'b11	:	SEGEN_O <= 4'b1000;
	endcase
     end
	 
	 //Weisst Registerbits den Portleitungen zu
   assign 	DP1OEN_O	=	!SEGEN_O[1];
   assign 	DP2OEN_O	=	!SEGEN_O[2];
   assign 	DP3OEN_O	=	!SEGEN_O[3];
   assign 	DP4OEN_O	=	!SEGEN_O[4];
	 	
	
	
// Das ist unsere Logik. Da die LEDs an Vcc angeschlossen sind leuchten
// sie wenn man einen Low-Pegel ausgibt.
// 
// Die Taster sind zwar auch invertiert angeschlossen, aber es gibt fuer 
// jeden Taste nochmal einen Inverter auf dem Board. Daher liefert eine
// gedrueckte Taste High-Pegel!

   // Taste1 gedrueckt schaltet Led1 ein. 
	//assign Led1 = !Taste1;
 //  assign Led2 = !Taste2;
	
	//Taste3 gedrueckt schaltet Led3 ein.
//	assign Led3 = !Taste3;
	
	//Led4 soll unser FlipFlop anzeigen.
//	assign Led4 = flipflop;
	
endmodule
